//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "configure.h"
#include <stdio.h>
#include "tools.h"
#include "borrowedfrommondo.h"
#include "starting.h"
#include "libmondo-EXT.h"
#include "XMondostructs.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TfrmConfigure *frmConfigure;

extern int ask_me_yes_or_no(char*);
extern void popup_and_OK(char*);

extern char g_config_file[MAX_STR_LEN];
extern char g_mountlist_sz[MAX_STR_LEN];
extern struct s_Configuration g_configuration;


void copy_settings_from_dialog_to_structure();
void copy_settings_from_structure_to_dialog();
void copy_checklistbox_selection_to_PChar(char *, TCheckListBox *);
void copy_PChar_to_checklistbox(TCheckListBox *, char *);
int find_index_number_of_string_in_checklistbox(TCheckListBox *, char *, bool);
void copy_PChar_to_checklistbox(TCheckListBox *, char *);
void check_PChar_entries_in_checklistbox(TCheckListBox *, char *);
int populate_checklistbox_from_mountlist(TCheckListBox *);
void disable_excluded_devices_in_checklist_window(TCheckListBox *, TCheckListBox *);
void disable_device_in_checklist_if_excluded(TCheckListBox *imagelist, TCheckListBox *exclist, int index);




//---------------------------------------------------------------------------
__fastcall TfrmConfigure::TfrmConfigure(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmConfigure::butCancelClick(TObject *Sender)
{
  Close();
//Release();
}
//---------------------------------------------------------------------------


void __fastcall TfrmConfigure::butSaveClick(TObject *Sender)
{
  if (!are_xmondo_config_box_settings_OK())
    {
      return;
    }
  else
    {
      g_configuration.configured_by_CONFIG_dialog = true;
      copy_settings_from_dialog_to_structure();
      save_config_file(g_config_file);
      Close();
    }
}
//---------------------------------------------------------------------------



/*
if (getuid()!=0)
  {
    frmConfigure->dtvBackupTheseDirs->Directory = "~";
  }
else
  {
    frmConfigure->dtvBackupTheseDirs->Directory = "/";
  }
*/




//---------------------------------------------------------------------------


void __fastcall TfrmConfigure::butChooseDevEntryClick(TObject *Sender)
{
odlChooseBkpDev->Execute();
fedBackupDevice->Text = odlChooseBkpDev->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TfrmConfigure::odlChooseBkpDevCanClose(TObject *Sender,
      bool &CanClose)
{
if (getuid()==0) { odlChooseBkpDev->InitialDir = "/"; }
else { odlChooseBkpDev->InitialDir = "/home"; }
}
//---------------------------------------------------------------------------

void __fastcall TfrmConfigure::rdgCompressionClick(TObject *Sender)
{
  char output[512];
  bool lzo_found;

  lzo_found = (system("which lzop &> /dev/null") == 0);
  if (rdgCompression->ItemIndex == 3)
    {
      if (! ask_me_yes_or_no("Are you sure?\nDisabling compression will waste\nspace and time unless your tape\ndrive supports hardware compression."))
        {
          if (lzo_found) { rdgCompression->ItemIndex = 2; }
          else { rdgCompression->ItemIndex = 1; }
        }
    }
  if (rdgCompression->ItemIndex == 2 && !lzo_found)
    {
      popup_and_OK("LZOP compression engine not installed.\nPlease install LZO and LZOP before\nyou try to choose 'minimum' compression.\n");
      rdgCompression->ItemIndex = 1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmConfigure::rdgMediaTypeClick(TObject *Sender)
{
  char result[512], res2[512], media_sz[512], tmp[512];
  int r;
  bool disable_mediasize = false;

  ediMediaSize->Enabled = true;
//  frmConfigure->Update();
  labDevice->Caption = "Thinking...";
  Application->ProcessMessages();
  switch(rdgMediaType->ItemIndex)
    {
      case 0: // tape
        strcpy(media_sz, "tape drive");
        r = find_tape_device_and_size(result, res2);
        fedBackupDevice->Text = result;
        labDevice->Caption = "Tape device:";
        ediMediaSize->Text = "n/a";
        disable_mediasize = true;
        break;
      case 1: // universal device
        strcpy(media_sz, "universal device");
        labDevice->Caption = "/dev entry:";
        ediMediaSize->Text = "n/a";
        r=1;
        disable_mediasize = true;
        break;
      case 2: // store ISO's
        strcpy(media_sz, "destination path");
        labDevice->Caption = "Dest. path:";
        r=1;
        ediMediaSize->Text = "650";
        break;
      case 3: // NFS
        strcpy(media_sz, "remote storage path");
        labDevice->Caption = "NFS share:";
        ediMediaSize->Text = "1900";
        r=1;
        break;
      case 4: // CD-R
        strcpy(media_sz, "CD-R drive's SCSI node");
        r = find_cdrw_device(result);
        fedBackupDevice->Text = result;
        labDevice->Caption = "CD-R node:";
        ediMediaSize->Text = "650";
        break;
      case 5: // CD-RW
        strcpy(media_sz, "CD-RW drive's SCSI node");
        r = find_cdrw_device(result);
        fedBackupDevice->Text = result;
        labDevice->Caption = "CD-RW node:";
        ediMediaSize->Text = "650";
        break;
      case 6: // CD stream
        strcpy(media_sz, "CD-stream drive's SCSI node");
        r = find_cdrw_device(result);
        fedBackupDevice->Text = result;
        labDevice->Caption = "CD-strm node:";
        ediMediaSize->Text = "650";
        break;
      default:
        popup_and_OK("Unknown device selection. Internal error.");
        media_sz[0] = '\0';
        labDevice->Caption = "Unknown:";
        ediMediaSize->Text = "";
        disable_mediasize = true;
        r=1;
    }
  if (r)
    {
      fedBackupDevice->Text = "";
      sprintf(tmp, "Please specify %s manually.", media_sz);
      popup_and_OK(tmp);
    }
  if (disable_mediasize)
    {
      ediMediaSize->Enabled = false;
    }
  else
    {
      ediMediaSize->Enabled = true;
      ediMediaSize->SetFocus();
    }
}
//---------------------------------------------------------------------------



void copy_settings_from_dialog_to_structure()
{
  WideString longtemp_sz;

  if (!frmConfigure->Visible)
    { popup_and_OK("Invisible!"); return; }
  log_it("Copying settings from dialog box to structure");
  switch(frmConfigure->rdgMediaType->ItemIndex)
    {
      case 0: g_configuration.backup_media_type = tape; break;
      case 1: g_configuration.backup_media_type = udev; break;
      case 2: g_configuration.backup_media_type = iso; break;
      case 3: g_configuration.backup_media_type = nfs; break;
      case 4: g_configuration.backup_media_type = cdr; break;
      case 5: g_configuration.backup_media_type = cdrw; break;
      case 6: g_configuration.backup_media_type = cdstream; break;
      default:g_configuration.backup_media_type = none; /* nothing */
    }

  WideStringToPChar(g_configuration.media_size, frmConfigure->ediMediaSize->Text, sizeof(g_configuration.media_size));
//  log_it("copy_settings_from_dialog_to_structure() --- media_size=%s", g_configuration.media_size);
  g_configuration.make_boot_floppies_at_end = (frmConfigure->chkBootFloppies->Checked ==true ? 1 : 0);
  g_configuration.compression_level = frmConfigure->rdgCompression->ItemIndex;
  g_configuration.use_lilo_instead_of_syslinux = (frmConfigure->chkLiloBF->Checked==true) ? 1 : 0;
  WideStringToPChar(g_configuration.boot_device, frmConfigure->fedBootDevice->Text, sizeof(g_configuration.boot_device));
  g_configuration.differential_backup = (frmConfigure->chkDifferential->Checked == true) ? 1 : 0;
  WideStringToPChar(g_configuration.kernel_path, frmConfigure->fedKernelPath->Text, sizeof(g_configuration.kernel_path));

  g_configuration.comparing = (frmConfigure->chkCompareAfter->Checked == true) ? 1 : 0;

  g_configuration.exclude_NFS_mounts = (frmConfigure->chkBackupNFSMounts->Checked == true) ? 0 : 1;

  WideStringToPChar(g_configuration.backup_path, frmConfigure->fedIncludePath->Text, sizeof(g_configuration.backup_path));

  WideStringToPChar(g_configuration.exclude_paths, frmConfigure->ediExcludePaths->Text, sizeof(g_configuration.exclude_paths));

  copy_checklistbox_selection_to_PChar(g_configuration.image_these_drives, frmConfigure->clbImageDrives);

  copy_checklistbox_selection_to_PChar(g_configuration.exclude_devices, frmConfigure->clbExcludeDevices);

  WideStringToPChar(g_configuration.media_device, frmConfigure->fedBackupDevice->Text, sizeof(g_configuration.media_device));

  if (frmConfigure->radGRUB->Checked) { g_configuration.boot_loader = 'G'; }

  else if (frmConfigure->radLILO->Checked) { g_configuration.boot_loader = 'L'; }
  log_it("copy_settings_from_dialog_to_structure() --- saving media_size = '%s' to struct", g_configuration.media_size);
}


void copy_settings_from_structure_to_dialog()
{
  char tmp[MAX_STR_LEN];
  char command[MAX_STR_LEN];
  char mountlist_fname[MAX_STR_LEN];

  log_it("Copying settings from structure to dialog box");
  switch(g_configuration.backup_media_type)
    {
      case tape: frmConfigure->rdgMediaType->ItemIndex = 0; break;
      case udev: frmConfigure->rdgMediaType->ItemIndex = 1; break;
      case iso:  frmConfigure->rdgMediaType->ItemIndex = 2; break;
      case nfs:  frmConfigure->rdgMediaType->ItemIndex = 3; break;
      case cdr:  frmConfigure->rdgMediaType->ItemIndex = 4; break;
      case cdrw: frmConfigure->rdgMediaType->ItemIndex = 5; break;
      case cdstream: frmConfigure->rdgMediaType->ItemIndex = 6; break;
      default:   frmConfigure->rdgMediaType->ItemIndex = -1; /* nothing */
    }
  frmConfigure->fedBackupDevice->Text = g_configuration.media_device;
  frmConfigure->ediMediaSize->Text = g_configuration.media_size;
  frmConfigure->chkBootFloppies->Checked = (g_configuration.make_boot_floppies_at_end ? true : false);
  frmConfigure->rdgCompression->ItemIndex = g_configuration.compression_level;
  frmConfigure->chkLiloBF->Checked = (g_configuration.use_lilo_instead_of_syslinux?true:false);
  frmConfigure->fedBootDevice->Text = g_configuration.boot_device;
  if (g_configuration.boot_loader == 'G') { frmConfigure->radGRUB->Checked = true; }
  if (g_configuration.boot_loader == 'L') { frmConfigure->radLILO->Checked = true; }
  frmConfigure->chkDifferential->Checked = (g_configuration.differential_backup) ? true : false;
  frmConfigure->fedKernelPath->Text = g_configuration.kernel_path;
  frmConfigure->chkCompareAfter->Checked = (g_configuration.comparing) ? true : false;
  frmConfigure->chkBackupNFSMounts->Checked = (g_configuration.exclude_NFS_mounts) ? false : true;
  frmConfigure->fedIncludePath->Text = g_configuration.backup_path;
  frmConfigure->ediExcludePaths->Text = g_configuration.exclude_paths;
  populate_checklistbox_from_mountlist(frmConfigure->clbImageDrives);
  populate_checklistbox_from_mountlist(frmConfigure->clbExcludeDevices);
  check_PChar_entries_in_checklistbox(frmConfigure->clbImageDrives, g_configuration.image_these_drives);
  check_PChar_entries_in_checklistbox(frmConfigure->clbExcludeDevices, g_configuration.exclude_devices);
  disable_excluded_devices_in_checklist_window(frmConfigure->clbImageDrives, frmConfigure->clbExcludeDevices);
  disable_excluded_devices_in_checklist_window(frmConfigure->clbExcludeDevices, frmConfigure->clbImageDrives);
  log_it("copy_settings_from_structure_to_dialog() -- copying %s to media_size dialog", g_configuration.media_size);
}



void disable_excluded_devices_in_checklist_window(TCheckListBox *imagelist, TCheckListBox *excdevs)
{
  int index;
  for(index=0; index < excdevs->Items->Count; index++)
    {
      disable_device_in_checklist_if_excluded(imagelist, excdevs, index);
    }
}





void disable_device_in_checklist_if_excluded(TCheckListBox *imagelist, TCheckListBox *exclist, int index)

{

  int found_here;

  char needle[MAX_STR_LEN];

  bool res=true;


  WideStringToPChar(needle, exclist->Items->Values[index+1], sizeof(needle));

  found_here = find_index_number_of_string_in_checklistbox(imagelist, needle, FALSE);

  if (found_here<0)
    {
      res = true;
      log_it("Enabling %s in imagelist", needle);
    }
  else if (exclist->Checked[found_here])
    {
      res = false;
      log_it("Disabling %s in imagelist", needle);
    }
  imagelist->ItemEnabled[found_here] = res;
}





bool are_xmondo_config_box_settings_OK()

{
  int res=0;
  char unset[MAX_STR_LEN], comment[MAX_STR_LEN];
  unset[0]='\0';
  if (!frmConfigure->radGRUB->Checked && !frmConfigure->radLILO->Checked)
    { res++; strcat(unset, "Please choose a boot loader (GRUB/LILO).\n"); }
  if (frmConfigure->fedBootDevice->Text == "")
    { res++; strcat(unset, "Please specify a boot device.\n"); }
  if (frmConfigure->fedKernelPath->Text == "")
    { res++; strcat(unset, "Please choose a kernel.\n"); }
  if (frmConfigure->rdgMediaType->ItemIndex == -1)
    { res++; strcat(unset, "Please choose a media type.\n"); }
  if (frmConfigure->ediMediaSize->Enabled && frmConfigure->ediMediaSize->Text == "")
    { res++; strcat(unset, "Please specify the size of media.\n"); }
  if (frmConfigure->fedBackupDevice->Text == "")
    { res++; strcat(unset, "Please specify output device/directory.\n"); }
  if (frmConfigure->fedIncludePath->Text == "")
    { res++; strcat(unset, "Please specify backup path (default='/').\n"); }
  if (frmConfigure->ediExcludePaths->Text == "/")
    { res++; strcat(unset, "Please fix your 'exclude paths' setting.\n"); }
  if (res)
    {
      sprintf(comment, "Before you save your settings:-\n%s", unset);
      popup_and_OK(comment);
    }
  return((res)?false:true);
}



void __fastcall TfrmConfigure::fedBackupDeviceClick(TObject *Sender)

{
  if (frmConfigure->rdgMediaType->ItemIndex == -1)
    {
      popup_and_OK("Please choose the backup media type first.");
      frmConfigure->rdgMediaType->SetFocus();
      return;
    }

}
//---------------------------------------------------------------------------




void __fastcall TfrmConfigure::chkDifferentialClick(TObject *Sender)

{
/*
  if (frmConfigure->chkDifferential->Checked)
    {
      ask_me_yes_or_no("
    }
*/
}
//---------------------------------------------------------------------------




void __fastcall TfrmConfigure::Button1Click(TObject *Sender)

{

  char output[MAX_STR_LEN];
/*  StringList->Add("Hi there");
  StringList->Add("What fun");
  frmConfigure->clbImageDrives->Items->Assign(StringList);
  frmConfigure->clbImageDrives->ItemIndex = 0;
*/

//  WideStringToPChar(output,

//  frmConfigure->clbImageDrives->
}
//---------------------------------------------------------------------------





void copy_checklistbox_selection_to_PChar(char *output_sz, TCheckListBox *listbox)

{

  int i, j, ch;

  char op[MAX_STR_LEN], comment[MAX_STR_LEN];

  AnsiString ansistr;


  output_sz[0]='\0';

//  log_it("copy_checklistbox_selection_to_PChar() --- starting");

  for(i=0; i < listbox->Items->Count; i++)

    {
      WideStringToPChar(op, listbox->Items->Values[i+1], sizeof(op));
      if (listbox->Checked[i])
        {
          sprintf(comment, "Line #%d (%s) is checked", i, op);
          strcat(output_sz, op);
          strcat(output_sz, " ");
          log_it(comment);
        }
      else
        {
          op[0] = '\0';
          sprintf(comment, "Line #%d (%s) is not checked", i, op);
        }
    }
  if (output_sz[(i=strlen(output_sz))-1] == ' ')
    { output_sz[--i]='\0'; }
//  log_it("Just converted checkboxlist to '%s'", output_sz);

//  log_it("copy_checklistbox_selection_to_PChar() --- leaving");

}




int find_index_number_of_string_in_checklistbox(TCheckListBox *listbox, char *searchstr, bool multicol)

/* if multicol then look for string as column #1 of N */

{

  int i;

  char op[MAX_STR_LEN], tmp[MAX_STR_LEN];


  for(i=0; i<listbox->Items->Count; i++)

    {

      WideStringToPChar(op, listbox->Items->Values[i+1], sizeof(op));

//      log_it("Looking for needle '%s' in haystack #%d '%s'", searchstr, i, op);

      if (!multicol && !strcmp(op, searchstr)) { return(i); }

      else

        {

          sprintf(tmp, "%s ", searchstr);

          if (!strncmp(op, tmp, strlen(tmp))) { return(i); }

        }

    }

  return(-1);

}




void copy_PChar_to_checklistbox(TCheckListBox *listbox_out, char *isz)

{

  int index;

  char *ptr, *nextp, incoming[MAX_STR_LEN], substr[MAX_STR_LEN/2];


  strcpy(incoming, isz);

  ptr = incoming;

  index = 1;

  while(ptr!=NULL)

    {

      nextp = strchr(ptr, ' ');

      if (nextp)

        {

          *nextp='\0';

          strcpy(substr, ptr);

          ptr = nextp;

          ptr++;

        }

      else

        {

          strcpy(substr, ptr);

          ptr = nextp;

        }

      if (strlen(substr)<3) {continue;}

//      log_it("#%d string is '%s'", index, substr);

      listbox_out->Items->Values[index++] = substr;

    }

}







void check_PChar_entries_in_checklistbox(TCheckListBox *listbox_out, char *isz)

{

  int index;

  char *ptr, *nextp, incoming[MAX_STR_LEN], substr[MAX_STR_LEN/2];


//  popup_and_OK("check_PChar_entries_in_checklistbox()");

//  return;


  if (!isz) { return; }

  if (isz[0]=='\0') { return; }

  log_it("check_PChar_entries_in_checklistbox() --- starting");

  for(index=0; index<listbox_out->Items->Count; index++) { listbox_out->Checked[index] = false; }

  strcpy(incoming, isz);

  ptr = incoming;

  while(ptr!=NULL)

    {

      nextp = strchr(ptr, ' ');

      if (nextp)

        {

          *nextp='\0';

          strcpy(substr, ptr);

          ptr = nextp;

          ptr++;

        }

      else

        {

          strcpy(substr, ptr);

          ptr = nextp;

        }

      if (strlen(substr)<3) {continue;}

      log_it("check_PChar_entries_in_checklistbox() --- looking at %s", substr);


      index = find_index_number_of_string_in_checklistbox(listbox_out, substr, FALSE);

//      log_it("eee --- index('%s') = %d", substr, index);

      if (index>=0)

        { listbox_out->Checked[index] = true; log_it("Found and checked %s", substr); }

      else

        { log_it("Cannot find %s in checklistbox", substr); }

    }

  log_it("check_PChar_entries_in_checklistbox() --- leaving");

}





int populate_checklistbox_from_mountlist(TCheckListBox *listbox)

{
  copy_PChar_to_checklistbox(listbox, g_mountlist_sz);
  return(0);
}




void __fastcall TfrmConfigure::chkBackupNFSMountsClick(TObject *Sender)

{
  if (!frmConfigure->chkBackupNFSMounts->Checked)
    {
      if (ask_me_yes_or_no("This is normally\na bad idea.\nAre you sure you\nwant to do this?"))
        {
          frmConfigure->chkBackupNFSMounts->Checked = true;
        }
    }
}
//---------------------------------------------------------------------------



void __fastcall TfrmConfigure::clbExcludeDevicesClickCheck(TObject *Sender)

{
  disable_device_in_checklist_if_excluded(
        frmConfigure->clbImageDrives, frmConfigure->clbExcludeDevices,
        frmConfigure->clbExcludeDevices->ItemIndex);
}
//---------------------------------------------------------------------------


void __fastcall TfrmConfigure::clbImageDrivesClickCheck(TObject *Sender)

{
  disable_device_in_checklist_if_excluded(
        frmConfigure->clbExcludeDevices, frmConfigure->clbImageDrives,
        frmConfigure->clbImageDrives->ItemIndex);

}
//---------------------------------------------------------------------------


void __fastcall TfrmConfigure::FormShow(TObject *Sender)

{
  copy_settings_from_structure_to_dialog();
}
//---------------------------------------------------------------------------



void __fastcall TfrmConfigure::FormClose(TObject *Sender,

      TCloseAction &Action)
{
//  copy_settings_from_structure_to_dialog();
}
//---------------------------------------------------------------------------




void __fastcall TfrmConfigure::FormCreate(TObject *Sender)

{
//  frmConfigure->rdgMediaType->ItemIndex = 3;
        
}
//---------------------------------------------------------------------------


