/* libmondo-EXT.h --------- DO NOT EDIT THIS FILE*/

/* my-stuff.h


11/22
- added INTERNAL_TAPE_BLK_SIZE

10/10
- use #define to create XMondo-friendly log file name if appropriate

08/30
- changed ARBITRARY_MAXIMUM to 512

08/26
- set MAX_STR_LEN at 512 but halved it within many _structures_
- changed ARBITRARY_MAXIMUM to 128

08/08
- added '#include <signal.h>'
- added WELCOME_STRING

06/19
- changed tape block size from 8192 to 65536

04/08
- added manual_cd_tray flag to bkpinfo

03/31
- added restore_path to struct s_bkpinfo

03/21
- updated version# to 1.42

02/20
- added bkpinfo->using_cdstream

02/06
- added MONDO_VERSION

02/02
- added MONDO_CFG_FILE
- added SLICE_SIZE

01/31
- removed MINDI_HOME: it is unnecessary
- replaced MONDO_HOME with variable g_mondo_home

01/25
- added MONDO_HOME, MINDI_HOME

01/21
- added s_node{} structure

01/17
- added sys/shm.h, types.h, ipc.h

01/02/2002
- added that groovy bkpinfo{} stuff

11/29/2001
- added raidlist{} struct

08/27
- stuff
*/

#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <getopt.h>
#include <errno.h>
#include <stddef.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>
#include <newt.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>


#ifdef DEBUG
int count;
char trace_log[255];		/*buffer for logging */
char *trace_log_ptr;
#endif /* DEBUG */





/*#define MONDO_VERSION "1.43"*/

/** added for debugging Stan Benoit 21 apr 2002 **/
#define MONDO_TRACEFILE	"/var/log/mondo-tracefile.log"
/** DEBUG add ****/


#define CRC_M16	0xA001		/* crc-16 mask */
#define	CRC_MTT	0x1021		/* crc-ccitt mask */

#define FALSE 0
#define TRUE 1

#define SCREEN_LENGTH 25
#define NOOF_ERR_LINES 6
#define ARBITRARY_MAXIMUM 512	/* max items in mountlist, filelist editor window */
#define MAX_STR_LEN 512
#define MAXIMUM_RAID_DEVS 32
#define MAXIMUM_ADDITIONAL_RAID_VARS 32
#define MAXIMUM_DISKS_PER_RAID_DEV 32

#define RAIDTAB_FNAME "/etc/raidtab"

#define BLK_START_OF_BACKUP     1
#define BLK_START_OF_TAPE       2
#define BLK_START_AFIOBALLS	10
#define BLK_STOP_AFIOBALLS	19
#define BLK_START_AN_AFIO_OR_SLICE    	20
#define BLK_STOP_AN_AFIO_OR_SLICE	29
#define BLK_START_BIGGIEFILES	30
#define BLK_STOP_BIGGIEFILES	39
#define BLK_START_A_BIGGIE	40
#define BLK_STOP_A_BIGGIE	59
#define BLK_START_FILE          80
#define BLK_STOP_FILE           89
#define BLK_END_OF_TAPE         100
#define BLK_END_OF_BACKUP       101
#define BLK_ABORTED_BACKUP      102
#define TAPE_BLOCK_SIZE 131072L	/* was 8192; 06/2002-->65536; 11/2002-->131072 */
#define INTERNAL_TAPE_BLK_SIZE 32768L /* 11/2002 */

//#define TAPE_BUF_SIZE           1*1024
//#define NOOF_TAPE_BUFS          4



#define SLICE_SIZE 8192







#define IS_THIS_A_STREAMING_BACKUP(x) (x == tape || x == udev || x == cdstream)


#define MONDO_MKISOFS_NONBOOT	"mkisofs -r -p MondoRescue -P www.mondorescue.com -A Mondo_Rescue_GPL_Version -V _CD#_"
#define MONDO_MKISOFS_REGULAR_SYSLINUX	"mkisofs -b isolinux.bin -no-emul-boot -boot-info-table -c boot.cat -boot-load-size 4 -r -p MondoRescue -P www.mondorescue.com -A Mondo_Rescue_GPL_Version -V _CD#_"
#define MONDO_MKISOFS_REGULAR_LILO      "mkisofs -b images/mindi-boot.2880.img -c boot.cat -J -r -p MondoRescue -P www.microwerks.net/~hugo/ -A Mondo_Rescue_GPL -V _CD#_"
#define MONDO_TMPISOS "/temporary.iso"


#define WELCOME_STRING "W E L C O M E   T O   M O N D O   R E S C U E"


//#define strcpy(y,x) strncpy(y, x, sizeof(y)-1)




#ifdef _XWIN
  #define MONDO_LOGFILE         "g_xmondo_logfile"
#else
  #define MONDO_LOGFILE           "/var/log/mondo-archive.log"
#endif


/***************************************************************************
                          mondostructures.h  -  description
                             -------------------
    begin                : Fri Apr 19 2002
    copyright            : (C) 2002 by Stan Benoit
    email                : troff@nakedsoul.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
struct mountlist_line
{
  char device[64];
  char mountpoint[64];
  char format[64];
  long size;
};

struct mountlist_itself
{
  int entries;
  struct mountlist_line el[ARBITRARY_MAXIMUM];
};

struct raid_var_line
{
  char label[64];
  char value[64];
};

struct additional_raid_variables
{
  int entries;
  struct raid_var_line el[MAXIMUM_ADDITIONAL_RAID_VARS];
};


struct s_disk
{
  char device[64];
  int index;
};

struct list_of_disks
{
  int entries;
  struct s_disk el[MAXIMUM_DISKS_PER_RAID_DEV];
};

typedef enum { none=0, iso, cdr, cdrw, cdstream, nfs, tape, udev } t_bkptype;

struct raid_device_record
{
  char raid_device[64];
  int raid_level;
  int persistent_superblock;
  int chunk_size;
  struct list_of_disks data_disks;
  struct list_of_disks spare_disks;
  struct list_of_disks parity_disks;
  struct list_of_disks failed_disks;
  struct additional_raid_variables additional_vars;
};

struct raidlist_itself
{
  int entries;
  struct raid_device_record el[MAXIMUM_RAID_DEVS];
};


#define MAX_NOOF_MEDIA 49

struct s_bkpinfo
{
  char media_device[MAX_STR_LEN/4];
  long media_size[MAX_NOOF_MEDIA+1];		/* in MB */
  char boot_loader;		/* G = GRUB, L = LILO */
  char boot_device[MAX_STR_LEN/4];	/* e.g. /dev/hda */
  char zip_exe[MAX_STR_LEN/4];	/* e.g. lzop or bzip2 */
  char zip_suffix[MAX_STR_LEN/4];	/* e.g. lzo or bz2 */
  char image_devs[MAX_STR_LEN/4];
  int compression_level;
  bool use_lzo;
  char do_not_compress_these[MAX_STR_LEN/2];
  bool verify_data;
  bool backup_data;
  bool restore_data;
  bool disaster_recovery;
  char isodir[MAX_STR_LEN/4];
  char scratchdir[MAX_STR_LEN/4];
  char tmpdir[MAX_STR_LEN/4];
  long optimal_set_size;
  t_bkptype backup_media_type;
  char include_paths[MAX_STR_LEN];
  char exclude_paths[MAX_STR_LEN];
  char restore_path[MAX_STR_LEN];
  char call_before_iso[MAX_STR_LEN];
  char call_make_iso[MAX_STR_LEN];
  char call_burn_iso[MAX_STR_LEN];
  char call_after_iso[MAX_STR_LEN];
  char kernel_path[MAX_STR_LEN];
  char nfs_mount[MAX_STR_LEN];
  char nfs_remote_dir[MAX_STR_LEN];
  char postnuke_tarball[MAX_STR_LEN];
  bool wipe_media_first;
  bool differential;
  int cdrw_speed;
  bool manual_cd_tray;
  bool nonbootable_backup;
  bool make_cd_use_lilo;
};




struct s_node
{
  char ch;
  struct s_node *right;
  struct s_node *down;
  bool selected;
  bool expanded;
};




struct s_wrapfifo {
	char public_device[MAX_STR_LEN/4]; // the one we write to / read from
	char private_device[MAX_STR_LEN/4];// the actual tape streamer
	char internal_buffer_IN_fifo[MAX_STR_LEN/4];
	char internal_buffer_OUT_fifo[MAX_STR_LEN/4];
	bool writing_to_private_device;
};




struct s_filename_and_lstat_info {
	char filename[MAX_STR_LEN];
	char checksum[64];
	char for_backward_compatibility;
	struct stat properties;
};



struct s_filelist_entry {
	char filename[MAX_STR_LEN];
	int severity; // 0 thru 3 --- 3 is most important
// 0 = /etc/mtab, /etc/adjtime, or other file which changes regularly
// 1 = 
};


struct s_filelist {
	int entries;
	struct s_filelist_entry el[ARBITRARY_MAXIMUM];
};



#include <stdio.h>


/* libmondo-archive-EXT.h */


extern int archive_this_fileset (struct s_bkpinfo *bkpinfo, char *filelist, char *fname, int setno);
extern bool can_we_fit_these_files_on_media (struct s_bkpinfo *bkpinfo, char*files_to_add, ...);
extern int do_that_initial_phase (struct s_bkpinfo *bkpinfo);
extern int do_that_final_phase (struct s_bkpinfo *bkpinfo);
extern int make_those_slices_phase (struct s_bkpinfo *bkpinfo);
extern int make_those_afios_phase (struct s_bkpinfo *bkpinfo);
extern int make_slices_and_images (struct s_bkpinfo *bkpinfo, char *biggielist_fname);
extern int make_iso_fs (struct s_bkpinfo *bkpinfo, char *destfile);
extern int make_afioballs_and_images (struct s_bkpinfo *bkpinfo);
extern int move_files_to_cd (struct s_bkpinfo *bkpinfo, char *, ...);
extern int move_files_to_stream (struct s_bkpinfo *bkpinfo, char *files_to_add, ...);
extern void pause_and_ask_for_cdr (int ask_for_one_if_more_than_this);
extern char *percent_media_full_comment (struct s_bkpinfo *bkpinfo);
extern int slice_up_file_etc (struct s_bkpinfo *bkpinfo, char *filename,
		   long biggie_file_number, long noof_biggie_files);
extern void wipe_archives (char *d);
extern int write_iso_and_go_on (struct s_bkpinfo *bkpinfo, bool last_cd);
extern int write_final_iso_if_necessary (struct s_bkpinfo *bkpinfo);

extern int figure_out_kernel_path_interactively_if_necessary(char*kernel);





extern int backup_data(struct s_bkpinfo *bkpinfo);


extern int verify_data(struct s_bkpinfo *bkpinfo);


extern int offer_to_write_boot_floppies_to_physical_disks(struct s_bkpinfo *bkpinfo);


extern int call_mindi_to_supply_boot_disks (struct s_bkpinfo *bkpinfo);


/* libmondo-devices-EXT.h */

extern bool am_I_in_disaster_recovery_mode (void);
extern bool does_device_exist (char *device);
extern int does_partition_exist (char *drive, int partno);
extern bool does_string_exist_in_boot_block (char *dev, char *str);
extern int find_and_mount_actual_cd (struct s_bkpinfo *bkpinfo, char *mountpoint);
extern int find_cdrom_device (char *output);
extern long get_phys_size_of_drive (char *drive);
extern bool is_this_a_valid_disk_format (char *format);
extern bool is_this_device_mounted (char *device_raw);
extern int find_device_in_mountlist (struct mountlist_itself *mountlist, char *device);
extern int mount_CDROM_here (char *device, char *mountpoint);
extern long size_of_specific_device_in_mountlist (struct mountlist_itself *mountlist, char *device);
extern char *where_is_root_mounted (void);
extern int make_list_of_drives (struct mountlist_itself *mountlist,
		     char drivelist[ARBITRARY_MAXIMUM][MAX_STR_LEN]);
extern char which_boot_loader (char *which_device);



extern int find_cdrw_device (char *cdrw_device);


extern int interactively_obtain_media_parameters_from_user(struct s_bkpinfo *, bool);


extern void make_fifo(char*store_name_here, char*stub);


extern void insist_on_this_cd_number (struct s_bkpinfo* bkpinfo, int cd_number_i_want);


extern int what_number_cd_is_this(struct s_bkpinfo *bkpinfo);


extern int eject_device(char*);

extern char *list_of_NFS_devices_and_mounts();

extern void sensibly_set_tmpdir_and_scratchdir(struct s_bkpinfo *bkpinfo);


extern bool set_dev_to_this_if_rx_OK(char*,char*);

/* libfifo-EXT.h */

extern void start_buffer_process(char*,char*,bool);
extern void wait_until_process_done(pid_t pid);
extern void stop_buffer_process(bool writing_to_private_device);





/* libmondo-filelist-EXT.h */

extern int chop_filelist (char *filelist, char *outdir, long maxsetsizeK);
extern void call_filelist_chopper (struct s_bkpinfo *bkpinfo);
extern void free_filelist (struct s_node *filelist);
extern int get_last_filelist_number (struct s_bkpinfo *bkpinfo);
extern int add_string_at_node (struct s_node *startnode, char *string_to_add);
extern struct s_node *load_filelist (char *filelist_fname);
extern void reload_filelist (struct s_node *filelist);
extern void save_filelist (struct s_node *filelist, char *outfname);
extern void toggle_all_root_dirs_on (struct s_node *filelist);
extern void toggle_path_expandability (struct s_node *filelist, char *pathname, bool on_or_off);
extern void toggle_path_selection (struct s_node *filelist, char *pathname, bool on_or_off);
extern void toggle_node_selection (struct s_node *filelist, bool on_or_off);
extern int prepare_filelist (struct s_bkpinfo *bkpinfo);

/* libmondo-files-EXT.h */

extern unsigned int updcrc (unsigned int crc, unsigned int c);
extern unsigned int updcrcr (unsigned int crc, unsigned int c);
extern char *calc_checksum_of_file (char *filename);
extern char *calc_file_ugly_minichecksum (char *curr_fname);
extern long count_lines_in_file (char *filename);
extern bool does_file_exist (char *filename);
extern void exclude_nonexistent_files (char *inout);
extern char *find_home_of_exe (char *fname);
extern int grab_percentage_from_last_line_of_file (char *filename);
extern char *last_line_of_file (char *filename);
extern long long length_of_file (char *filename);
extern int make_checksum_list_file (char *filelist, char *cksumlist, char *comppath);
extern int make_hole_for_file (char *outfile_fname);
extern void make_list_of_files_to_ignore (char *ignorefiles_fname, char *filelist_fname,
			      char *cklist_fname);
extern long noof_lines_that_match_wildcard (char *filelist_fname, char *wildcard);
extern void register_pid(pid_t pid, char*name_str);
extern long long space_occupied_by_cd (char *mountpt);
extern int whine_if_not_found (char *fname);
extern int write_one_liner_data_file (char *fname, char *contents);



extern long size_of_all_biggiefiles_K (struct s_bkpinfo *bkpinfo);
extern void copy_mondo_and_mindi_stuff_to_scratchdir (struct s_bkpinfo *bkpinfo);
extern void store_nfs_config (struct s_bkpinfo *bkpinfo);


extern void estimate_noof_media_required (struct s_bkpinfo *bkpinfo,long);

extern bool is_this_file_compressed (char*);

/* libmondo-fork-EXT.h */

extern char *call_program_and_get_last_line_of_output (char *call);
extern int run_program_and_log_to_screen (char *basic_call, char *what_i_am_doing);
extern int run_program_and_log_output (char *program, bool);
extern int eval_call_to_make_ISO (struct s_bkpinfo *bkpinfo,
	   char *basic_call, char *isofile,
	   int cd_no, char *logstub, char *what_i_am_doing);

/* libmondo-mountlist-EXT.h */

extern int evaluate_drive_within_mountlist (struct mountlist_itself *mountlist,
				 char *drive, char *flaws_str);
extern int evaluate_mountlist (struct mountlist_itself *mountlist, char *flaws_str_A,
		    char *flaws_str_B, char *flaws_str_C);
extern int find_device_in_mountlist (struct mountlist_itself *mountlist, char *device);
extern int look_for_duplicate_mountpoints (struct mountlist_itself *mountlist, char *flaws_str);
extern int look_for_weird_formats (struct mountlist_itself *mountlist, char *flaws_str);
extern int make_list_of_drives_in_mountlist(struct mountlist_itself*, char drivelist[ARBITRARY_MAXIMUM][MAX_STR_LEN]);
extern long size_of_specific_device_in_mountlist (struct mountlist_itself *mountlist, char *device);




/* libmondo-raid-EXT.h */


extern bool is_this_raid_personality_registered (int raidno);
extern int which_raid_device_is_using_this_partition (struct raidlist_itself *raidlist,
					   char *device);
extern void write_variableINT_to_raid_var_line (struct raid_device_record *raidrec,
				    int lino, char *label, int value);

extern int where_in_drivelist_is_drive (struct list_of_disks *disklist, char *device);

/* libmondo-stream-EXT.h */



extern void insist_on_this_tape_number(int tapeno);

extern int closein_cdstream (struct s_bkpinfo *bkpinfo);
extern int closein_tape (struct s_bkpinfo *bkpinfo);
extern int closeout_tape (struct s_bkpinfo *bkpinfo);
extern int openin_cdstream (struct s_bkpinfo *bkpinfo);
extern int openin_tape (struct s_bkpinfo *bkpinfo);
extern int openout_cdstream (char *cddev, int speed);
extern int openout_tape (char *tapedev);
extern int read_file_from_stream_to_file (struct s_bkpinfo *bkpinfo, char *outfile,
			     long long size);
extern int read_file_from_stream_to_stream (struct s_bkpinfo *bkpinfo, FILE * fout,
			       long long size);
extern int read_file_from_stream_FULL (struct s_bkpinfo *bkpinfo, char *outfname,
			  FILE * foutstream, long long orig_size);
extern int read_header_block_from_stream (long long *plen, char *filename,
			     int *pcontrol_char);
extern bool should_we_write_to_next_tape (long mediasize, long long length_of_incoming_file);
extern int start_to_read_from_next_tape (struct s_bkpinfo *bkpinfo);
extern int start_to_write_to_next_tape (struct s_bkpinfo *bkpinfo);
extern int write_data_disks_to_stream (char *fname);
extern int write_file_to_stream_from_file (struct s_bkpinfo *bkpinfo, char *infile);
extern int write_header_block_to_stream (long long length_of_incoming_file, char *filename,
			    int control_char);
extern void wrong_marker (int should_be, int it_is);








extern void log_tape_pos (void);


extern int find_tape_device_and_size(char*device, char*siz);



/* libmondo-string-EXT.h */




extern char *build_partition_name (char *partition, char *drive, int partno);
extern void center_string (char *in_out, int width);
extern char *commarize (char*);
extern char *disklist_entry_to_string (struct list_of_disks *disklist, int lino);
extern long friendly_sizestr_to_sizelong (char *incoming);
extern char *leftpad_string (char *incoming, int width);
extern char *marker_to_string (int marker);
extern char *mountlist_entry_to_string (struct mountlist_itself *mountlist, int lino);
extern char *number_of_disks_as_string (int noof_disks, char *label);
extern char *number_to_text (int i);
extern void resolve_naff_tokens (char *output, char *ip, char *value, char *token);
extern char *slice_fname (long bigfileno, long sliceno, char *path, char *s);
extern int special_dot_char (int i);
extern bool spread_flaws_across_three_lines (char *flaws_str, char *flaws_str_A,
				 char *flaws_str_B, char *flaws_str_C,
				 int res);
extern int strcmp_inc_numbers (char *stringA, char *stringB);
extern char * strip_afio_output_line (char *input);
extern void strip_spaces (char *in_out);
extern char *trim_empty_quotes (char *incoming);
extern char *truncate_to_drive_name (char *partition);
extern char *turn_raid_level_number_to_string (int raid_level);

extern void printf_silly_message(void);

extern int compare_two_filelist_entries(void*va,void*vb);
extern int severity_of_difference(char *filename, char *out_reason);

/* libmondo-tools-EXT.h */

extern long get_time ();
extern void log_it (char *, ...);
extern int read_cfg_var (char *config_file, char *label, char *value);
extern int write_cfg_var (char *config_file, char *label, char *value);
extern void reset_bkpinfo (struct s_bkpinfo *bkpinfo);
extern void initialize_raidrec (struct raid_device_record *raidrec);
extern void log_trace (char *o);
extern int some_basic_system_sanity_checks ();



extern void malloc_global_string(char**x);




extern void insmod_crucial_modules(void);
extern int find_and_store_mondoarchives_home(char *home_sz);

extern void unmount_supermounts_if_necessary(void);
extern void remount_supermounts_if_necessary(void);

extern int post_param_configuration (struct s_bkpinfo *bkpinfo);


extern int pre_param_configuration(struct s_bkpinfo *bkpinfo);


extern void mount_boot_if_necessary(void);
extern void unmount_boot_if_necessary(void);
/* libmondo-verify-EXT.h */


extern int verify_cd_image (struct s_bkpinfo *);
extern int verify_an_afioball (struct s_bkpinfo *, char *);
extern int verify_an_afioball_from_CD (struct s_bkpinfo *, char *);
extern int verify_an_afioball_from_tape (struct s_bkpinfo *, char *, long long);
extern int verify_a_biggiefile_from_tape (struct s_bkpinfo *, char *, long long);
int verify_afioballs_from_CD (struct s_bkpinfo *);
extern int verify_afioballs_from_tape (struct s_bkpinfo *);
extern int verify_biggiefiles_from_tape (struct s_bkpinfo *);
extern int verify_tape_backups (struct s_bkpinfo *);
extern char *vfy_tball_fname (struct s_bkpinfo *, char *, int);


/* X-specific-EXT.h */


extern int ask_me_yes_or_no (char *prompt);
extern int ask_me_OK_or_cancel (char *prompt);
extern void close_evalcall_form (void);
extern void close_progress_form ();
extern void fatal_error (char *error_string);
extern void finish (int signal);
extern void mvaddstr_and_log_it (int y, int x, char *output);
extern void open_evalcall_form (char *title);
extern void open_progress_form (char *title, char *b1, char *b2, char *b3, long max_val);
extern void log_file_end_to_screen (char *filename, char *grep_for_me);
extern void log_to_screen (char *op);
extern void popup_and_OK (char *prompt);
extern bool popup_and_get_string (char *title, char *b, char *output);
extern int popup_with_buttons (char *p, char *button1, char *button2);
extern void refresh_log_screen ();
extern void setup_newt_stuff ();
extern void update_evalcall_form_ratio (int num, int denom);
extern void update_evalcall_form (int curr);
extern void update_progress_form (char *blurb3);
extern void update_progress_form_full (char *blurb1, char *blurb2, char *blurb3);





extern t_bkptype which_backup_media_type (bool);
extern int which_compression_level ();


extern void popup_changelist_from_file(char*source_file);


