//---------------------------------------------------------------------------

#include <clx.h>
#include "main.h"
#include "progressform.h"
#include "borrowedfrommondo.h"
#include "tools.h"
#include "libmondo-EXT.h"
#include "XMondostructs.h"
//#include <errno.h>
#include <process.h>

#pragma hdrstop



/*
GUI SUBROUTINES NOW AVAILABLE:-
        ask_me_OK_or_cancel()   in main.cpp
        ask_me_yes_or_no()      in main.cpp
        close_progress_form()   in progressform.cpp
        fatal_error()           in progressform.cpp
        finish()                in progressform.cpp
        log_it()                in libmondo.cpp
        log_to_screen()         in progressform.cpp
        mvaddstr_and_log_it()   in progressform.cpp
        popup_and_OK()          in main.cpp
        popup_and_get_string()  in main.cpp
        open_progress_form()    in progressform.cpp
        update_progress_form()  in progressform.cpp

TODO
        void close_evalcall_form (void);
        void log_file_end_to_screen (char *filename, char *grep_for_me);
        void open_evalcall_form (char *title);
        void update_evalcall_form_ratio (int num, int denom);
        void update_evalcall_form (int curr);
        void popup_changelist_from_file(char*source_file);
*/

/*
#ifndef MAX_STR_LEN
  #define MAX_STR_LEN 512
#endif
*/

extern long g_current_progress;
extern pid_t g_main_pid;
extern bool g_skip_floppies;
extern void sub_to_call_mondoarchive(void*params);
extern void sub_to_call_mondorestore(void*params);

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TfrmProgress *frmProgress;

void update_progress_form(char*);
void open_progress_form (char *title, char *b1, char *b2, char *b3, long max_val);
int backup_backup_backup(void);
extern struct s_Configuration g_configuration;
extern bool g_mondoarchiveisrunning;
void setup_newt_stuff(void*);

/* copied from newt-specific.c */
long g_maximum_progress = 999;	/* purpose */
long g_current_progress = -999;	/* purpose */
long g_start_time = 0;		/* purpose */
long g_isoform_starttime;
int g_isoform_old_progress = -1;
char g_isoform_header_str[MAX_STR_LEN];
int g_mysterious_dot_counter;
int g_currentY = 3;		/* purpose */
extern int g_current_media_number;
//int g_mondo_finish_result = -9999;
extern char err_log_lines[NOOF_ERR_LINES][MAX_STR_LEN];
void log_file_end_to_screen(char*,char*);


//---------------------------------------------------------------------------
__fastcall TfrmProgress::TfrmProgress(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void fatal_error (char *error_string)
{
  char tmp[MAX_STR_LEN];
  sprintf(tmp, "Fatal error - %s", error_string);
  popup_and_OK(tmp);
//  g_mondo_finish_result = 1;
  _endthread();
}


void finish(int res)
{
  char tmp[MAX_STR_LEN];
  sprintf(tmp, "finish() called with res=%d", res);
  popup_and_OK(tmp);
  log_it(tmp);
//  g_mondo_finish_result = res;
  _endthread();
}



void setup_newt_stuff(void)
{
  log_it("setup_newt_stuff() --- empty function :-)");
}



void show_or_hide_all_progress_form_components(bool yes_or_no)
{
  frmProgress->pgbProgressBar->Visible = yes_or_no;
  frmProgress->labTitle->Visible = yes_or_no;
  frmProgress->labFirstBlurb->Visible = yes_or_no;
  frmProgress->labSecondBlurb->Visible = yes_or_no;
  frmProgress->labThirdBlurb->Visible = yes_or_no;
  frmProgress->labTimeTaken->Visible = yes_or_no;
  frmProgress->labTimeTogo->Visible = yes_or_no;
  frmProgress->labPcTaken->Visible = yes_or_no;
  frmProgress->labPcTogo->Visible = yes_or_no;
}


void log_to_screen(char*new_line)
{
  int i;

  for(i=0; i<5; i++)
    { strcpy(err_log_lines[i], err_log_lines[i+1]); }
  strcpy(err_log_lines[i], new_line);

  log_it(new_line);
  frmProgress->labLog1->Caption = err_log_lines[NOOF_ERR_LINES-5];
  frmProgress->labLog2->Caption = err_log_lines[NOOF_ERR_LINES-4];
  frmProgress->labLog3->Caption = err_log_lines[NOOF_ERR_LINES-3];
  frmProgress->labLog4->Caption = err_log_lines[NOOF_ERR_LINES-2];
  frmProgress->labLog5->Caption = err_log_lines[NOOF_ERR_LINES-1];
  Application->ProcessMessages();
  if (!g_mondoarchiveisrunning) { log_it("Terminating thread"); _endthread(); }
}



void mvaddstr_and_log_it (int y, int x, char *output)
{
  static char str_to_log[MAX_STR_LEN];
  int i;
  static int last_Y=0;

  if (y!=last_Y)
    {
      last_Y = y;
      for(i=0; i<100; i++) { str_to_log[i] = ' '; }
      str_to_log[i] = '\0';
    }
  if (x>60) { x=60; }
  strcpy(str_to_log+x, output);
  if (x >= 60)
    { last_Y=0; }
  log_to_screen(str_to_log);
  for(i=strlen(str_to_log); i<100; i++) { str_to_log[i] = ' '; }
  str_to_log[i] = '\0';
}



void open_progress_form (char *title, char *b1, char *b2, char *b3, long max_val)
{
  show_or_hide_all_progress_form_components(true);
  frmProgress->labTitle->Caption = title;
  frmProgress->labFirstBlurb->Caption =b1;
  frmProgress->labSecondBlurb->Caption=b2;
  frmProgress->labThirdBlurb->Caption =b3;

  log_to_screen(title);
/* copied from newt-specific.c */
  g_start_time = get_time ();
  g_maximum_progress = max_val;
  g_current_progress = 0;
  frmProgress->pgbProgressBar->Min = 0;
  frmProgress->pgbProgressBar->Max = max_val;
  frmProgress->pgbProgressBar->Position = 0;
  update_progress_form(b3);
}




void update_progress_form(char*str1)
{
  long current_time = 0;
  long time_taken = 0;
  long time_remaining = 0;
  long time_total_est = 0;

	/** int ********************************************************/
  int percentage = 0;
	int i = 0;

	/** buffers ****************************************************/
  char percentline_str[MAX_STR_LEN];
	char timeline_str[MAX_STR_LEN];
	char taskprogress[MAX_STR_LEN];
	char tmp[MAX_STR_LEN];

  current_time = get_time ();
  time_taken = current_time - g_start_time;
  if (g_maximum_progress == 0)
    {
      percentage = 0;
    }
  else
    {
      if (g_current_progress > g_maximum_progress)
	{
	  g_current_progress = g_maximum_progress;
	}
      percentage = (int) ((g_current_progress * 100L) / g_maximum_progress);
    }
  if (percentage < 1)
    {
      percentage = 1;
    }
  if (percentage > 100)
    {
      percentage = 100;
    }
  if (g_current_progress)
    {
      time_total_est = time_taken * (long) g_maximum_progress / (long) (g_current_progress);
      time_remaining = time_total_est - time_taken;
    }
  else
    {
      time_remaining = 0;
    }
//  g_mysterious_dot_counter = (g_mysterious_dot_counter + 1) % 27;

  sprintf (tmp, "%2ld:%02ld taken", time_taken / 60, time_taken % 60);
  frmProgress->labTimeTaken->Caption = tmp;

  sprintf (tmp,"%2ld:%02ld remaining  ", time_remaining / 60, time_remaining % 60);
  frmProgress->labTimeTogo->Caption = tmp;

  sprintf (tmp, "%3d%% done", percentage);
  frmProgress->labPcTaken->Caption = tmp;

  sprintf (tmp, "%3d%% to go", 100 - percentage);
  frmProgress->labPcTogo->Caption = tmp;

  frmProgress->labThirdBlurb->Caption = str1;
  frmProgress->pgbProgressBar->Position = g_current_progress;

  Application->ProcessMessages();
  if (!g_mondoarchiveisrunning) { log_it("Terminating thread"); _endthread(); }
}


void close_progress_form(void)
{
  g_current_progress = g_maximum_progress;
  update_progress_form("Complete");
  log_to_screen("Complete");
  sleep(1);
  show_or_hide_all_progress_form_components(false);
}





void __fastcall TfrmProgress::FormShow(TObject *Sender)
{
  g_mondoarchiveisrunning = true;
  frmMain->butBackup->Enabled = false;
  frmMain->butCompare->Enabled = false;
  frmMain->butRestore->Enabled = false;
  frmMain->labPleaseWaitBackingUp->Visible = true;
  frmMain->pgbProgress->Visible = true;
  show_or_hide_all_progress_form_components(false);
//  Application->ProcessMessages();

}
//---------------------------------------------------------------------------

void __fastcall TfrmProgress::FormHide(TObject *Sender)
{
  frmMain->labPleaseWaitBackingUp->Visible = false;
  frmMain->butBackup->Enabled = true;
  frmMain->butCompare->Enabled = true;
  frmMain->butRestore->Enabled = true;
//  Application->ProcessMessages();
  g_mondoarchiveisrunning = false;

}
//---------------------------------------------------------------------------






int backup_backup_backup(void)
{
  int result_of_call_to_mondo=-9999, i;
  unsigned long lres;
  char tmp[MAX_STR_LEN];

  g_configuration.backing_up = true;
  if (!g_configuration.configured_by_CONFIG_dialog)
    {
      popup_and_OK("Please run the 'Configure' dialog\nunder the 'Options' menu.");
      return(1);
    }
  else if (frmProgress->Visible)
    {
      popup_and_OK("Sorry, a process is already running.\nTerminate it if you dare...");
      return(1);
    }
//  g_mondo_finish_result = -9999;
//  frmProgress->Show();
//  _beginthread(backup_SUB,4096,(void*)NULL);
  _beginthread(sub_to_call_mondoarchive,4096,(void*)(&result_of_call_to_mondo));
  g_mondoarchiveisrunning = true;
  while(result_of_call_to_mondo == -9999)
    {
      usleep(500000);
      Application->ProcessMessages();
    }
  g_mondoarchiveisrunning = false;
//  frmProgress->Hide();
//  result_of_call_to_mondo = g_mondo_finish_result;
  return(result_of_call_to_mondo);
}



int compare_compare_compare(void)
{
  int result_of_call_to_mondo=-9999, i;
  unsigned long lres;
  char tmp[MAX_STR_LEN];

  g_configuration.comparing = true;
  g_configuration.backing_up = false;
  if (!g_configuration.configured_by_CONFIG_dialog)
    {
      popup_and_OK("Please run the 'Configure' dialog\nunder the 'Options' menu.");
      return(1);
    }
  else if (frmProgress->Visible)
    {
      popup_and_OK("Sorry, a process is already running.\nTerminate it if you dare...");
      return(1);
    }
  _beginthread(sub_to_call_mondoarchive,4096,(void*)(&result_of_call_to_mondo));
  g_mondoarchiveisrunning = true;
  while(result_of_call_to_mondo == -9999)
    {
      usleep(500000);
      Application->ProcessMessages();
    }
  g_mondoarchiveisrunning = false;
  return(result_of_call_to_mondo);
}





int restore_restore_restore(void)
{
  int result_of_call_to_mondo=-9999, i;
  unsigned long lres;
  char tmp[MAX_STR_LEN];

  if (!g_configuration.configured_by_CONFIG_dialog)
    {
      popup_and_OK("Please run the 'Configure' dialog\nunder the 'Options' menu.");
      return(1);
    }
  else if (frmProgress->Visible)
    {
      popup_and_OK("Sorry, a process is already running.\nTerminate it if you dare...");
      return(1);
    }
  _beginthread(sub_to_call_mondorestore,4096,(void*)(&result_of_call_to_mondo));
  g_mondoarchiveisrunning = true;
  while(result_of_call_to_mondo == -9999)
    {
      usleep(500000);
      Application->ProcessMessages();
    }
  g_mondoarchiveisrunning = false;
  return(result_of_call_to_mondo);
}




void __fastcall TfrmProgress::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{

  if (ask_me_yes_or_no("Are you SURE you\nwant to do this?"))
    {
     g_mondoarchiveisrunning = false;
//     g_mondo_finish_result = 32100;// aborted
     CanClose = true;
     }
  else {
     CanClose = false;
    }
}
//---------------------------------------------------------------------------

void open_evalcall_form(char*heading)
{
  char tmp[MAX_STR_LEN];

  sprintf(tmp, "open_evalcall_form --- %s", heading);
  log_to_screen(tmp);
  update_evalcall_form(0);
}



void update_evalcall_form(int a)
{
  char tmp[MAX_STR_LEN];

  sprintf(tmp, "update_evalcall_form --- %d", a);
  log_to_screen(tmp);
}


void close_evalcall_form(void)
{
  log_to_screen("close_evalcall_form --- closing");
}



void log_file_end_to_screen(char*a, char*b)
{
  log_it("log_file_end_to_screen('%s', '%s')", a, b);
  popup_and_OK("log_file_end_to_screen --- not coded yet");
}





