/* tools.cpp


09/30
- added craft_a_call_string_to_mondoarchive
- moved many subroutines to borrowedfrommondo.c

09/23
- added WideStringToPChar()
- added call_mondoarchive()

09/20
- added find_kernel_path() and which_boot_loader()
- added open_web_browser_in_background()

09/13
- created
*/


#include "tools.h"
#include "configure.h"
#include "borrowedfrommondo.h"
#include "progressform.h"
#include <process.h>

void call_binary_in_background(void*vsz);
void log_it (char *incoming, ...);
//char *WidestringToPChar(wchar_t* incoming);
int open_web_browser_in_background(char*webpage);
int call_mondoarchive(void);
bool g_mondotermisrunning;
int call_mondoarchive_in_its_own_terminal(void);
char *craft_a_call_string_to_mondoarchive(char *extra_string);
int save_config_file(char *configfile);
void popup_and_show_logfile(char *logfile);
char g_config_file[MAX_STR_LEN];
struct s_Configuration g_configuration;

extern bool ask_me_yes_or_no(char*);

extern char g_homedir[MAX_STR_LEN];



void call_binary_in_background(void*vsz)
{
  char *command;
  int res;

  command = (char*)vsz;
  res = system(command);
  _endthread();
}



int call_mondoarchive()
{
  int res, len, pos, j;
  char command[MAX_STR_LEN*2];
  char result_fname[MAX_STR_LEN], *crafted_call;
  char temp_crafted[MAX_STR_LEN];
  char tmp[MAX_STR_LEN], *ptr;
  char incoming[5][80];
  char stdin_fifo[MAX_STR_LEN], stdout_fifo[MAX_STR_LEN];
  int stdin_fd, stdout_fd;

  incoming[0][0] = incoming[1][0] = incoming[2][0] = incoming[3][0] = incoming[4][0] = '\0';

//  crafted_call = craft_a_call_string_to_mondoarchive("-g");
  strcpy(temp_crafted, find_home_of_exe("mondoarchive.dummy"));
  crafted_call = temp_crafted;

  if (!crafted_call) { return(1); }
  frmProgress->Show();
  make_fifo(stdin_fifo, "/tmp/XMondo-fifo.");
  make_fifo(stdout_fifo, "/tmp/XMondo-fifo.");
  sprintf(result_fname, "/tmp/XMondo.fork.%d", (int)(random()%32767));
  sprintf(command, "bash -c 'rm -f %s; %s < %s > %s; echo $? > %s'", result_fname, crafted_call, stdout_fifo, stdin_fifo, result_fname);
  log_it("Command is %s", command);
//  res+=system(command);
  _beginthread(call_binary_in_background,4096,(void*)command);
  log_it("Opening FD's");
  stdout_fd= open(stdout_fifo, O_WRONLY | O_NONBLOCK);
  log_it("...");
  stdin_fd = open(stdin_fifo, O_RDONLY | O_NONBLOCK);
  log_it("Proceeding");
  for(pos=(len=read(stdin_fd, tmp, 16)); len>=0; pos+=(len=read(stdin_fd, tmp, 16)))
    {
      if (!len) { sleep(1); continue; }
      log_it("pos = %d; len = %d; tmp (so far) = %s", tmp);
      if (strchr(tmp, '\n'))
        {
          for(j=0; j<4; j++) { strcpy(incoming[j], incoming[j+1]); }
          strcpy(incoming[j], tmp);
          ptr = strchr(incoming[j], '\n');
          strcpy(tmp, ptr+1);
          *ptr = '\0';
          update_progress_form(incoming[2], incoming[3], incoming[4], incoming[5]);
          log_it(incoming[5]);
        }
      else if (strstr(tmp, "--Q-->"))
        {
          log_it("Writing 'yes' to out");
          write(stdout_fd, "yes\n", 4);
        }
      Application->ProcessMessages();
    }
  log_it("Closing FD's");
  close(stdin_fd);
  close(stdout_fd);
  if (len<0) { log_it("Premature closure"); res++; }

  strcpy(tmp, last_line_of_file(result_fname));
  strip_spaces(tmp);
  log_it("mondoarchive returned string/val '%s'", tmp);
  if (atoi(tmp)!=0 || !does_file_exist(result_fname)
  || !system("grep -i \"signal from the OS\" /var/log/mondo-archive.log &> /dev/null"))
    { res++; }
  if (res)
    {
      popup_and_show_logfile("/var/log/mondo-archive.log");
    }
  unlink(result_fname);
  unlink(stdin_fifo);
  unlink(stdout_fifo);
  frmProgress->Hide();
  return(res);
}





int call_mondoarchive_in_its_own_terminal()
{
  int res;
  char command[MAX_STR_LEN*2];
  char result_fname[MAX_STR_LEN], *crafted_call;
  char tmp[MAX_STR_LEN], *ptr;

  crafted_call = craft_a_call_string_to_mondoarchive("-g");
  if (!crafted_call) { return(1); }
  sprintf(result_fname, "/tmp/XMondo.fork.%d", (int)(random()%32767));
  sprintf(command, "rm -f %s; %s +cm +hold -e %s; echo $? > %s", result_fname, find_home_of_exe("xterm"), crafted_call, result_fname);
  log_it("Command is %s", command);
  res+=system(command);
  strcpy(tmp, last_line_of_file(result_fname));
  strip_spaces(tmp);
  log_it("mondoarchive returned string/val '%s'", tmp);
  if (atoi(tmp)!=0 || !does_file_exist(result_fname)
  || !system("grep -i \"signal from the OS\" /var/log/mondo-archive.log &> /dev/null"))
    { res++; }
  if (res)
    {
      popup_and_show_logfile("/var/log/mondo-archive.log");
    }
  unlink(result_fname);
  return(res);
}




char *craft_a_call_string_to_mondoarchive(char *extra_string)
{
  static char command[MAX_STR_LEN];

  sprintf(command, "%s -n 15 mondoarchive -O %s", find_home_of_exe("nice"), extra_string);
  if (g_configuration.kernel_path[0])
    { sprintf(command+strlen(command), " -k %s", g_configuration.kernel_path); }
  switch(g_configuration.boot_loader)
    {
      case 'G':
        sprintf(command+strlen(command), " -l GRUB");
        break;
      case 'L':
        sprintf(command+strlen(command), " -l LILO");
        break;
      default:
        log_it("Warning - weird boot loader");
    }
  if (g_configuration.boot_device[0])
    { sprintf(command+strlen(command), " -f %s", g_configuration.boot_device); }
  switch(g_configuration.compression_level)
    {
      case 0:
        sprintf(command+strlen(command), " -9");
        break;
      case 1:
        sprintf(command+strlen(command), " -3");
        break;
      case 2:
        sprintf(command+strlen(command), " -L");
        break;
      case 3:
        sprintf(command+strlen(command), " -0");
        break;
      default:
        log_it("Warning - weird compression settings found");
    }
  if (g_configuration.image_these_drives[0])
    { sprintf(command+strlen(command), " -x \"%s\"", g_configuration.image_these_drives); }
  if (g_configuration.backup_path[0])
    { sprintf(command+strlen(command), " -I \"%s\"", g_configuration.backup_path); }
  if (g_configuration.exclude_devices[0] || g_configuration.exclude_paths[0])
    { sprintf(command+strlen(command), " -E \"%s %s\"", g_configuration.exclude_devices, g_configuration.exclude_paths); }
  if (!g_configuration.make_boot_floppies_at_end)
    { strcat(command, " -F"); }
  if (g_configuration.compare_after_bkp)
    { sprintf(command+strlen(command), " -V"); }
  if (g_configuration.use_lilo_instead_of_syslinux)
    { strcat(command, " -o"); }
  switch(g_configuration.backup_media_type)
    {
      case tape:
        if (!g_configuration.media_device[0])
          { strcpy(g_configuration.media_device, "/dev/st0"); popup_and_OK("No media device specified; defaulting to /dev/st0"); }
        sprintf(command+strlen(command), " -t -d %s", g_configuration.media_device);
        break;
      case udev:
        sprintf(command+strlen(command), " -u -d %s", g_configuration.media_device);
        break;
      case iso:
        sprintf(command+strlen(command), " -i -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case nfs:
        sprintf(command+strlen(command), " -nd %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdr:
        if (!g_configuration.media_device[0])
          { strcpy(g_configuration.media_device, "0,1,0"); popup_and_OK("No media device specified; defaulting to 0,1,0"); }
        sprintf(command+strlen(command), " -r 4 -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdrw:
        sprintf(command+strlen(command), " -w 4 -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdstream:
        sprintf(command+strlen(command), " -C -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      default:
        popup_and_OK("Please configure XMondo before\nyou try to backup your data.");
        return(NULL);
    }
  if (!g_configuration.media_device[0])
    { popup_and_OK("No backup device specified. Aborting."); return(NULL); }

  return(command);
}





void create_simple_config_file(char *outfile)
{
  strcpy( g_configuration.media_device, "" );
  g_configuration.make_boot_floppies_at_end = TRUE;
  g_configuration.compression_level = 1; // 0 thru 3, 3 being _none_
  g_configuration.backup_media_type = none;
  g_configuration.use_lilo_instead_of_syslinux = FALSE;
  strcpy(g_configuration.exclude_devices, call_program_and_get_last_line_of_output("cat /etc/fstab | grep -vx \"#.*\" | grep -iw zip | tr -s ' ' '\t' | head -n1 | cut -f1"));
  log_it("g_configuration.exclude_devices = '%s'", g_configuration.exclude_devices);
  strcpy(g_configuration.image_these_drives, call_program_and_get_last_line_of_output("cat /etc/fstab | grep -vx \"#.*\" | grep -i ntfs | tr -s ' ' '\t' | head -n1 | cut -f1"));
  g_configuration.media_size[0] = '\0';
  g_configuration.boot_loader = which_boot_loader(g_configuration.boot_device);
//  log_it("Boot device = %c, %s", g_configuration.boot_loader, g_configuration.boot_device);
  find_kernel_path(g_configuration.kernel_path);
//  log_it("Kernel path is %s", g_configuration.kernel_path);
  log_it("Imaging drives %s", g_configuration.image_these_drives);
  g_configuration.compare_after_bkp = true;
  g_configuration.backup_media_type = none; // unknown
  g_configuration.exclude_NFS_mounts = true;
  strcpy(g_configuration.exclude_paths, "");
  strcpy(g_configuration.backup_path, "/");
  save_config_file(outfile);
}


int load_config_file(char *configfile)
{
  FILE*fin;
  int res=0;

  log_it("Loading config file");
  if (!(fin = fopen(configfile, "r"))) { log_it("Failed to load config file"); res++; }
  else
    {
      if (fread((void*)&g_configuration, 1, sizeof(g_configuration), fin) < sizeof(g_configuration))
        { log_it("Failed to read entire configuation file"); res++; }
      fclose(fin);
    }
  if (res)
    {
      log_it("Loading defaults");
      create_simple_config_file(configfile);
    }
  else
    { log_it("Loaded config file OK"); }
  log_it("Loaded media_device as %s", g_configuration.media_device);
  log_it("Loaded exclude_devices as '%s'", g_configuration.exclude_devices);
  return(res);
}





void
log_it (char *incoming, ...)
{
	/** pointers *****************************************************/
  FILE *fout;

	/** buffers ******************************************************/
  char output[MAX_STR_LEN*4];

	/** int    *******************************************************/
  int i;

	/** end vars ****************************************************/
  char fnam[MAX_STR_LEN];

  va_list ap;

  va_start(ap, incoming);
  vsprintf(output, incoming, ap);
  i = strlen (output);
  if (i <= 0)
    {
      return;
    }
  if (output[i - 1] < 32)
    {
      output[--i] = '\0';
    }

      sprintf( fnam, "%s/XMondo.log", g_homedir);
      fout = fopen ( fnam, "a");
      if (fout)
        {
          fprintf (fout, "%s\n", output);
          fclose (fout);
        }

  va_end(ap);
}





int open_web_browser_in_background(char*webpage)
{
  char command[512];

  if (strstr(webpage, "http://"))
    {
      sprintf(command, "ping -c1 %s", webpage);
      if (run_program_and_log_output(command, FALSE))
        { log_it("Web page is down (or I'm not on the Net)"); return(1); }
    }
  strcpy(command, find_home_of_exe("konqueror"));
  if (!command[0])
    { strcpy(command, find_home_of_exe("mozilla")); }
  if (!command[0])
    { strcpy(command, find_home_of_exe("netscape")); }
  if (!command[0])
    { return(2); }
  else
    {
      strcat(command, " ");
      strcat(command, webpage);
      strcat(command, " &");
      system(command);
      return(0);
    }
}




void popup_and_show_logfile(char *logfile)
{
  char *ptr;
  char command[MAX_STR_LEN];
  
      if ((ptr=find_home_of_exe("emacs")))
        { strcpy(command, ptr); }
      else if ((ptr=find_home_of_exe("kedit")))
        { strcpy(command, ptr); }
      else
        { sprintf(command, "%s +cm +hold -e less", find_home_of_exe("xterm")); }
      strcat(command, " ");
      strcat(command, logfile);
      if (!strstr(command, "xterm")) { strcat(command, " &"); }
      log_it(command);
      system(command);
}



int save_config_file(char *configfile)
{
  FILE*fout;
  int res=0;

  log_it("Saving config file");
  if (!(fout = fopen(configfile, "w"))) { log_it("Failed to save config file"); return(1); }
  if (fwrite((void*)&g_configuration, 1, sizeof(g_configuration), fout) < sizeof(g_configuration))
    { log_it("Failed to write entire configuation file"); res++; }
  fclose(fout);
//  log_it("FYI, g_configuration->use_lilo_instead_of_syslinux is %d", g_configuration.use_lilo_instead_of_syslinux);
  if (!res) { log_it("Saved config file OK"); }
  log_it("Saved media_device as %s", g_configuration.media_device);
  return(res);
}





