/* tools.cpp


09/30
- added craft_a_call_string_to_mondoarchive
- moved many subroutines to borrowedfrommondo.c

09/23
- added WideStringToPChar()
- added call_mondoarchive()

09/20
- added find_kernel_path() and which_boot_loader()
- added open_web_browser_in_background()

09/13
- created
*/

#include <errno.h>
#include "libmondo-EXT.h"
#include "borrowedfrommondo.h"
#include "tools.h"
#include "configure.h"
#include "progressform.h"
#include <process.h>
#include "XMondostructs.h"




int call_a_binary_in_its_own_terminal(char*);
void call_binary_in_background(void*vsz);
void log_it (char *incoming, ...);
//char *WidestringToPChar(wchar_t* incoming);
int open_web_browser_in_background(char*webpage);
int call_mondoarchive(void);
bool g_mondotermisrunning;
int call_mondoarchive_in_its_own_terminal(void);
int call_mondorestore_in_its_own_terminal(void);
char *craft_a_call_string_to_mondoarchive(char *extra_string);
int save_config_file(char *configfile);
void popup_and_show_logfile(char *logfile);
char g_config_file[MAX_STR_LEN];
void copy_info_from_Configuration_struct_to_bkpinfo_struct(struct s_bkpinfo*);
extern char err_log_lines[NOOF_ERR_LINES][MAX_STR_LEN];

extern int ask_me_yes_or_no(char*);

extern char g_homedir[MAX_STR_LEN];

int g_cbib_res=-9999;
struct s_Configuration g_configuration;
bool g_skip_floppies=false;

void call_binary_in_background(void*vsz)
{
  char *command;
  int res;

  command = (char*)vsz;
  log_it("Calling %s in background", command);
  res = system(command);
  log_it("Done with background call to %s; result = %d", command, res);
  g_cbib_res = res;
  _endthread();
}



int call_mondoarchive()
{
  const log_window_width=90;
  int res=0, len, pos, j;
  char command[MAX_STR_LEN*2];
  char result_fname[MAX_STR_LEN], *crafted_call;
  char temp_crafted[MAX_STR_LEN];
  char tmp[MAX_STR_LEN], *ptr;
  char incoming[5][log_window_width];
  char mondo_fifo[MAX_STR_LEN];
  char output_fifo[MAX_STR_LEN];
  char temporary_logfile[MAX_STR_LEN];
  FILE*fin;
  int fd_in;

  incoming[0][0] = incoming[1][0] = incoming[2][0] = incoming[3][0] = incoming[4][0] = '\0';
  make_fifo(mondo_fifo, "/tmp/XMondo-fifo.");
  unlink(mondo_fifo);
  make_fifo(output_fifo, "/tmp/XMondo-output.");
  sprintf(result_fname, "/tmp/%d.%d.%d", (int)(random()%32768), (int)(random()%32768), (int)(random()%32768) );
  sprintf(temporary_logfile, "/tmp/%d.%d.%d", (int)(random()%32768), (int)(random()%32768), (int)(random()%32768) );

//  crafted_call = craft_a_call_string_to_mondoarchive("-X");
  sprintf(temp_crafted, "/usr/local/mondo-1.5x/mondo/mondotest/mondotest %s", mondo_fifo);
  crafted_call = temp_crafted;

  if (!crafted_call) { return(1); }
  sprintf(command, "%s > %s", crafted_call, output_fifo);
  log_it("Command is %s", command);
  _beginthread(call_binary_in_background,4096,(void*)command);
//  if (system(command)) { log_it("system() failed"); return(1); }

  log_it("Opening FD's");
//  frmProgress->Show();

/*
  if ((fd_in = open(output_fifo, O_RDONLY | O_NONBLOCK)<0)) { log_it("Failed to open temp logfile"); return(1); }
  for(pos=(len=read(fd_in, tmp, 16)); len>=0; pos+=(len=read(fd_in, tmp, 16)))
    {
      if (g_cbib_res != -9999) { log_it("bkgd process is no longer running"); res = g_cbib_res; break; }
      if (!len) { usleep(100); continue; }
      log_it("pos = %d; len = %d; tmp (so far) = %s", tmp);
      if (strchr(tmp, '\n'))
        {
          for(j=0; j<4; j++) { strcpy(incoming[j], incoming[j+1]); }
          strcpy(incoming[j], tmp);
          ptr = strchr(incoming[j], '\n');
          strcpy(tmp, ptr+1);
          *ptr = '\0';
          log_it(incoming[j]);
//          update_progress_form(incoming[1], incoming[2], incoming[3], incoming[4]);
          sleep(1);
          if (strstr(tmp, "--Q--"))
            {
              log_it("Saying 'yes' to question");
              sprintf(command, "echo yes > %s", mondo_fifo);
              system(command);
              log_it("Done");
            }
        }
      Application->ProcessMessages();
    }
  log_it("Closing FD's");
  close(fd_in);
*/

  if (!(fin = fopen(output_fifo, "r"))) { log_it("Failed to open temp logfile"); return(1); }
  while(!feof(fin))
    {
      for(j=0; j<4; j++) { strcpy(incoming[j], incoming[j+1]); }
      fgets(tmp, MAX_STR_LEN, fin);
      strncpy(incoming[j], tmp, log_window_width);
      tmp[log_window_width-1] = '\0';
      if (incoming[j][(len = strlen(incoming[j]))-1] < 32) { incoming[j][--len] = '\0'; }
      update_progress_form(incoming[2], incoming[3], incoming[4], incoming[5]);
      log_it(incoming[j]);
      usleep(10000);
      if (strstr(incoming[j], "---Q---"))
        {
          log_it("Saying 'yes' to question");
          sprintf(command, "echo yes > %s", mondo_fifo);
          system(command);
          log_it("Done");
        }
    }
  fclose(fin);

//  frmProgress->Hide();
  strcpy(tmp, last_line_of_file("/var/log/mondo-archive.log"));
  strip_spaces(tmp);
  ptr = strstr(tmp, "retval=");
  if (ptr)
    {
      ptr = strchr(tmp, '=') + 1;
      res = atoi(ptr);
    }
  else if (!system("grep -i \"signal from the OS\" /var/log/mondo-archive.log &> /dev/null")
  || !system("grep -i \"Errors occurred during backup\" /var/log/mondo-archive.log &> /dev/null"))
    { res++; }
  if (res)
    {
      popup_and_show_logfile("/var/log/mondo-archive.log");
    }
  unlink(result_fname);
  unlink(mondo_fifo);
  unlink(output_fifo);
  return(res);
}





int call_a_binary_in_its_own_terminal(char*sz_call)
{
  int res;
  char command[MAX_STR_LEN*2];
  char result_fname[MAX_STR_LEN];
  char tmp[MAX_STR_LEN], *ptr;

  sprintf(result_fname, "/tmp/XMondo.fork.%d", (int)(random()%32767));
  sprintf(command, "rm -f %s; %s +cm +hold -e %s; echo $? > %s", result_fname, find_home_of_exe("xterm"), sz_call, result_fname);
  log_it("Command is %s", command);
  res+=system(command);
  strcpy(tmp, last_line_of_file(result_fname));
  strip_spaces(tmp);
  log_it("mondoarchive returned string/val '%s'", tmp);
  if (atoi(tmp)==0 && does_file_exist(result_fname))
    { log_it("0 was returned. Great. I think no error occurred."); }
  else if (!does_file_exist(result_fname) || !system("grep -i \"signal from the OS\" /var/log/mondo-archive.log &> /dev/null"))
    { res++; log_it("Either no result_fname file was returned and/or a signal from OS terminated mondoarchive."); }
  if (res)
    {
      popup_and_show_logfile("/var/log/mondo-archive.log");
    }
  unlink(result_fname);
  return(res);
}




int call_mondoarchive_in_its_own_terminal()
{
  char sz_call[MAX_STR_LEN];

  strcpy(sz_call, craft_a_call_string_to_mondoarchive("-g"));
  if (!sz_call) { return(1); }
  return(call_a_binary_in_its_own_terminal(sz_call));
}





int call_mondorestore_in_its_own_terminal()
{
  char sz_call[MAX_STR_LEN];

  strcpy(sz_call, find_home_of_exe("mondorestore"));
  if (!sz_call) { return(1); }
  return(call_a_binary_in_its_own_terminal(sz_call));
}



char *craft_a_call_string_to_mondoarchive(char *extra_string)
{
  static char command[MAX_STR_LEN];

  sprintf(command, "%s -n 15 mondoarchive %s", find_home_of_exe("nice"), extra_string);
  if (g_configuration.backing_up)
    { strcat(command, " -O"); }
  if (g_configuration.kernel_path[0])
    { sprintf(command+strlen(command), " -k %s", g_configuration.kernel_path); }
  switch(g_configuration.boot_loader)
    {
      case 'G':
        sprintf(command+strlen(command), " -l GRUB");
        break;
      case 'L':
        sprintf(command+strlen(command), " -l LILO");
        break;
      default:
        log_it("Warning - weird boot loader");
    }
  if (g_configuration.boot_device[0])
    { sprintf(command+strlen(command), " -f %s", g_configuration.boot_device); }
  switch(g_configuration.compression_level)
    {
      case 0:
        sprintf(command+strlen(command), " -9");
        break;
      case 1:
        sprintf(command+strlen(command), " -3");
        break;
      case 2:
        sprintf(command+strlen(command), " -L");
        break;
      case 3:
        sprintf(command+strlen(command), " -0");
        break;
      default:
        log_it("Warning - weird compression settings found");
    }
  if (g_configuration.image_these_drives[0])
    { sprintf(command+strlen(command), " -x \"%s\"", g_configuration.image_these_drives); }
  if (g_configuration.backup_path[0])
    { sprintf(command+strlen(command), " -I \"%s\"", g_configuration.backup_path); }
  if (g_configuration.exclude_devices[0] || g_configuration.exclude_paths[0])
    { sprintf(command+strlen(command), " -E \"%s %s\"", g_configuration.exclude_devices, g_configuration.exclude_paths); }
  if (!g_configuration.make_boot_floppies_at_end)
    { strcat(command, " -F"); }
  if (g_configuration.comparing)
    { sprintf(command+strlen(command), " -V"); }
  if (g_configuration.use_lilo_instead_of_syslinux)
    { strcat(command, " -o"); }
  switch(g_configuration.backup_media_type)
    {
      case tape:
        if (!g_configuration.media_device[0])
          { strcpy(g_configuration.media_device, "/dev/st0"); popup_and_OK("No media device specified; defaulting to /dev/st0"); }
        sprintf(command+strlen(command), " -t -d %s", g_configuration.media_device);
        break;
      case udev:
        sprintf(command+strlen(command), " -u -d %s", g_configuration.media_device);
        break;
      case iso:
        sprintf(command+strlen(command), " -i -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case nfs:
        sprintf(command+strlen(command), " -nd %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdr:
        if (!g_configuration.media_device[0])
          { strcpy(g_configuration.media_device, "0,1,0"); popup_and_OK("No media device specified; defaulting to 0,1,0"); }
        sprintf(command+strlen(command), " -r 4 -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdrw:
        sprintf(command+strlen(command), " -w 4 -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      case cdstream:
        sprintf(command+strlen(command), " -C -d %s -s %s", g_configuration.media_device, g_configuration.media_size);
        strcat(command, "m");
        break;
      default:
        popup_and_OK("Please configure XMondo before\nyou try to backup your data.");
        return(NULL);
    }
  if (!g_configuration.media_device[0])
    { popup_and_OK("No backup device specified. Aborting."); return(NULL); }

  return(command);
}





void create_simple_config_file(char *outfile)
{
  strcpy( g_configuration.media_device, "" );
  g_configuration.make_boot_floppies_at_end = TRUE;
  g_configuration.compression_level = 1; // 0 thru 3, 3 being _none_
  g_configuration.backup_media_type = none;
  g_configuration.use_lilo_instead_of_syslinux = FALSE;
  strcpy(g_configuration.exclude_devices, call_program_and_get_last_line_of_output("cat /etc/fstab | grep -vx \"#.*\" | grep -iw zip | tr -s ' ' '\t' | head -n1 | cut -f1"));
  log_it("g_configuration.exclude_devices = '%s'", g_configuration.exclude_devices);
  strcpy(g_configuration.image_these_drives, call_program_and_get_last_line_of_output("cat /etc/fstab | grep -vx \"#.*\" | grep -i ntfs | tr -s ' ' '\t' | head -n1 | cut -f1"));
  g_configuration.media_size[0] = '\0';
  log_it("create_simple_config_file() --- Asking which_boot_loader()");
  g_configuration.boot_loader = which_boot_loader(g_configuration.boot_device);
//  log_it("Boot device = %c, %s", g_configuration.boot_loader, g_configuration.boot_device);
  find_kernel_path(g_configuration.kernel_path);
//  log_it("Kernel path is %s", g_configuration.kernel_path);
  log_it("Imaging drives %s", g_configuration.image_these_drives);
  g_configuration.comparing = true;
  g_configuration.backup_media_type = none; // unknown
  g_configuration.exclude_NFS_mounts = true;
  strcpy(g_configuration.exclude_paths, "");
  strcpy(g_configuration.backup_path, "/");
  save_config_file(outfile);
}


int load_config_file(char *configfile)
{
  FILE*fin;
  int res=0;

  log_it("Loading config file");
  if (!(fin = fopen(configfile, "r"))) { log_it("Failed to load config file"); res++; }
  else
    {
      if (fread((void*)&g_configuration, 1, sizeof(g_configuration), fin) < sizeof(g_configuration))
        { log_it("Failed to read entire configuation file"); res++; }
      fclose(fin);
    }
  if (res)
    {
      log_it("Loading defaults");
      create_simple_config_file(configfile);
    }
  else
    { log_it("Loaded config file OK"); }
  log_it("Loaded media_device as %s", g_configuration.media_device);
  log_it("Loaded media_size as %s", g_configuration.media_size);
  log_it("Loaded exclude_devices as '%s'", g_configuration.exclude_devices);
  return(res);
}





void
log_it (char *incoming, ...)
{
	/** pointers *****************************************************/
  FILE *fout;

	/** buffers ******************************************************/
  char output[MAX_STR_LEN*4];

	/** int    *******************************************************/
  int i;

	/** end vars ****************************************************/
  char fnam[MAX_STR_LEN];

  va_list ap;

  va_start(ap, incoming);
  vsprintf(output, incoming, ap);
  i = strlen (output);
  if (i <= 0)
    {
      return;
    }
  if (output[i - 1] < 32)
    {
      output[--i] = '\0';
    }

      sprintf( fnam, "%s/XMondo.log", g_homedir);
      fout = fopen ( fnam, "a");
      if (fout)
        {
          fprintf (fout, "%s\n", output);
          fclose (fout);
        }

  va_end(ap);
}





int open_web_browser_in_background(char*webpage)
{
  char command[512];

  if (strstr(webpage, "http://"))
    {
      sprintf(command, "ping -c1 %s", webpage);
      if (run_program_and_log_output(command, FALSE))
        { log_it("Web page is down (or I'm not on the Net)"); return(1); }
    }
  strcpy(command, find_home_of_exe("konqueror"));
  if (!command[0])
    { strcpy(command, find_home_of_exe("mozilla")); }
  if (!command[0])
    { strcpy(command, find_home_of_exe("netscape")); }
  if (!command[0])
    { return(2); }
  else
    {
      strcat(command, " ");
      strcat(command, webpage);
      strcat(command, " &");
      system(command);
      return(0);
    }
}




void popup_and_show_logfile(char *logfile)
{
  char *ptr;
  char command[MAX_STR_LEN];
  
      if ((ptr=find_home_of_exe("emacs")))
        { strcpy(command, ptr); }
      else if ((ptr=find_home_of_exe("kedit")))
        { strcpy(command, ptr); }
      else
        { sprintf(command, "%s +cm +hold -e less", find_home_of_exe("xterm")); }
      strcat(command, " ");
      strcat(command, logfile);
      if (!strstr(command, "xterm")) { strcat(command, " &"); }
      log_it(command);
      system(command);
}



int save_config_file(char *configfile)
{
  FILE*fout;
  int res=0;

  log_it("Saving config file");
  if (!(fout = fopen(configfile, "w"))) { log_it("Failed to save config file"); return(1); }
  if (fwrite((void*)&g_configuration, 1, sizeof(g_configuration), fout) < sizeof(g_configuration))
    { log_it("Failed to write entire configuation file"); res++; }
  fclose(fout);
//  log_it("FYI, g_configuration->use_lilo_instead_of_syslinux is %d", g_configuration.use_lilo_instead_of_syslinux);
  if (!res) { log_it("Saved config file OK"); }
  log_it("Saved media_device as %s", g_configuration.media_device);
  log_it("Saved media_size as %s", g_configuration.media_size);
  return(res);
}




void copy_info_from_Configuration_struct_to_bkpinfo_struct(struct s_bkpinfo *bkpinfo)
{
  int i;
  char tmp[MAX_STR_LEN];

  if (g_configuration.kernel_path[0])
    { strcpy(bkpinfo->kernel_path, g_configuration.kernel_path); }
  bkpinfo->boot_loader =g_configuration.boot_loader;
  if (g_configuration.boot_device[0])
    { strcpy(bkpinfo->boot_device, g_configuration.boot_device); }
  switch(g_configuration.compression_level)
    {
      case 0:
        bkpinfo->compression_level = 9;
        break;
      case 1:
        bkpinfo->compression_level = 3;
        break;
      case 2:
        bkpinfo->use_lzo = true;
        break;
      case 3:
        bkpinfo->compression_level = 0;
        break;
      default:
        log_it("Warning - weird compression settings found");
    }
  if (g_configuration.image_these_drives[0])
    { strcpy(bkpinfo->image_devs, g_configuration.image_these_drives); }
  if (g_configuration.backup_path[0])
    { strcpy(bkpinfo->include_paths, g_configuration.backup_path); }
  if (g_configuration.exclude_devices[0] || g_configuration.exclude_paths[0])
    { sprintf(bkpinfo->exclude_paths, "%s %s", g_configuration.exclude_devices, g_configuration.exclude_paths); }
  if (!g_configuration.make_boot_floppies_at_end)
    { g_skip_floppies = true; }
  if (g_configuration.comparing)
    { bkpinfo->verify_data = true; }
  if (g_configuration.use_lilo_instead_of_syslinux)
    { bkpinfo->make_cd_use_lilo = true; }
  bkpinfo->backup_media_type = g_configuration.backup_media_type;
  strcpy(bkpinfo->media_device, g_configuration.media_device);
  log_it("FYI, media_size = '%s'", g_configuration.media_size);
  if (!IS_THIS_A_STREAMING_BACKUP(bkpinfo->backup_media_type))
    {
      strcpy(tmp, g_configuration.media_size);
      strcat(tmp, "m");
      for(i=0; i<MAX_NOOF_MEDIA; i++) { bkpinfo->media_size[i] = friendly_sizestr_to_sizelong(tmp); }
    }
}


